__all__ = [
    "dmap_data_types", "dmap_names", "dmap_reverse_data_types",
    "dmap_code_types"]

dmap_code_types = {
    "abal": ("daap.browsealbumlisting", 12),
    "abar": ("daap.browseartistlisting", 12),
    "abcp": ("daap.browsecomposerlisting", 12),
    "abgn": ("daap.browsegenrelisting", 12),
    "abpl": ("daap.baseplaylist", 1),
    "abro": ("daap.databasebrowse", 12),
    "adbs": ("daap.databasesongs", 12),
    "aeAI": ("com.apple.itunes.itms-artistid", 5),
    "aeCI": ("com.apple.itunes.itms-composerid", 5),
    "aeEN": ("com.apple.itunes.episode-num-str", 9),
    "aeES": ("com.apple.itunes.episode-sort", 5),
    "aeFP": ("com.apple.itunes.req-fplay", 1),
    "aeGD": ("com.apple.itunes.gapless-enc-dr", 5),
    "aeGE": ("com.apple.itunes.gapless-enc-del", 5),
    "aeGH": ("com.apple.itunes.gapless-heur", 5),
    "aeGI": ("com.apple.itunes.itms-genreid", 5),
    "aeGR": ("com.apple.itunes.gapless-resy", 7),
    "aeGU": ("com.apple.itunes.gapless-dur", 7),
    "aeHV": ("com.apple.itunes.has-video", 1),
    "aeMK": ("com.apple.itunes.mediakind", 1),
    "aeMQ": ("com.apple.itunes.unknown-MQ", 1),
    "aeNN": ("com.apple.itunes.network-name", 9),
    "aeNV": ("com.apple.itunes.norm-volume", 5),
    "aePC": ("com.apple.itunes.is-podcast", 1),
    "aePI": ("com.apple.itunes.itms-playlistid", 5),
    "aePP": ("com.apple.itunes.is-podcast-playlist", 1),
    "aePS": ("com.apple.itunes.special-playlist", 1),
    "aeSF": ("com.apple.itunes.itms-storefrontid", 5),
    "aeSI": ("com.apple.itunes.itms-songid", 5),
    "aeSL": ("com.apple.itunes.unknown-SL", 1),
    "aeSN": ("com.apple.itunes.series-name", 9),
    "aeSP": ("com.apple.itunes.smart-playlist", 1),
    "aeSR": ("com.apple.itunes.unknown-SR", 1),
    "aeSU": ("com.apple.itunes.season-num", 5),
    "aeSV": ("com.apple.itunes.music-sharing-version", 5),
    "aeTr": ("com.apple.itunes.unknown-Tr", 1),
    "agrp": ("daap.songgrouping", 9),
    "aply": ("daap.databaseplaylists", 12),
    "aprm": ("daap.playlistrepeatmode", 1),
    "apro": ("daap.protocolversion", 11),
    "apsm": ("daap.playlistshufflemode", 1),
    "apso": ("daap.playlistsongs", 12),
    "arif": ("daap.resolveinfo", 12),
    "arsv": ("daap.resolve", 12),
    "asaa": ("daap.songalbumartist", 9),
    "asac": ("daap.songartworkcount", 3),
    "asal": ("daap.songalbum", 9),
    "asar": ("daap.songartist", 9),
    "asbk": ("daap.bookmarkable", 1),
    "asbo": ("daap.songbookmark", 5),
    "asbr": ("daap.songbitrate", 3),
    "asbt": ("daap.songbeatsperminute", 3),
    "ascd": ("daap.songcodectype", 5),
    "ascm": ("daap.songcomment", 9),
    "ascn": ("daap.songcontentdescription", 9),
    "asco": ("daap.songcompilation", 1),
    "ascp": ("daap.songcomposer", 9),
    "ascr": ("daap.songcontentrating", 1),
    "ascs": ("daap.songcodecsubtype", 5),
    "asct": ("daap.songcategory", 9),
    "asda": ("daap.songdateadded", 10),
    "asdb": ("daap.songdisabled", 1),
    "asdc": ("daap.songdisccount", 3),
    "asdk": ("daap.songdatakind", 1),
    "asdm": ("daap.songdatemodified", 10),
    "asdn": ("daap.songdiscnumber", 3),
    "asdp": ("daap.songdatepurchased", 10),
    "asdr": ("daap.songdatereleased", 10),
    "asdt": ("daap.songdescription", 9),
    "ased": ("daap.songextradata", 3),
    "aseq": ("daap.songeqpreset", 9),
    "asfm": ("daap.songformat", 9),
    "asgn": ("daap.songgenre", 9),
    "asgp": ("daap.songgapless", 1),
    "asgr": ("daap.supportsgroups", 4),
    "ashp": ("daap.songhasbeenplayed", 1),
    "asky": ("daap.songkeywords", 9),
    "aslc": ("daap.songlongcontentdescription", 9),
    "asrv": ("daap.songrelativevolume", 2),
    "assa": ("daap.sortartist", 9),
    "assc": ("daap.sortcomposer", 9),
    "assl": ("daap.sortalbumartist", 9),
    "assn": ("daap.sortname", 9),
    "assp": ("daap.songstoptime", 5),
    "assr": ("daap.songsamplerate", 5),
    "asss": ("daap.sortseriesname", 9),
    "asst": ("daap.songstarttime", 5),
    "assu": ("daap.sortalbum", 9),
    "assz": ("daap.songsize", 5),
    "astc": ("daap.songtrackcount", 3),
    "astm": ("daap.songtime", 5),
    "astn": ("daap.songtracknumber", 3),
    "asul": ("daap.songdataurl", 9),
    "asur": ("daap.songuserrating", 1),
    "asyr": ("daap.songyear", 3),
    "ated": ("daap.supportsextradata", 3),
    "avdb": ("daap.serverdatabases", 12),
    "mbcl": ("dmap.bag", 12),
    "mccr": ("dmap.contentcodesresponse", 12),
    "mcna": ("dmap.contentcodesname", 9),
    "mcnm": ("dmap.contentcodesnumber", 5),
    "mcon": ("dmap.container", 12),
    "mctc": ("dmap.containercount", 5),
    "mcti": ("dmap.containeritemid", 5),
    "mcty": ("dmap.contentcodestype", 3),
    "mdcl": ("dmap.dictionary", 12),
    "miid": ("dmap.itemid", 5),
    "mikd": ("dmap.itemkind", 1),
    "mimc": ("dmap.itemcount", 5),
    "minm": ("dmap.itemname", 9),
    "mlcl": ("dmap.listing", 12),
    "mlid": ("dmap.sessionid", 5),
    "mlit": ("dmap.listingitem", 12),
    "mlog": ("dmap.loginresponse", 12),
    "mpco": ("dmap.parentcontainerid", 5),
    "mper": ("dmap.persistentid", 7),
    "mpro": ("dmap.protocolversion", 11),
    "mrco": ("dmap.returnedcount", 5),
    "msal": ("dmap.supportsautologout", 1),
    "msas": ("dmap.authenticationschemes", 5),
    "msau": ("dmap.authenticationmethod", 1),
    "msbr": ("dmap.supportsbrowse", 1),
    "msdc": ("dmap.databasescount", 5),
    "msed": ("dmap.supportsedit", 1),
    "msex": ("dmap.supportsextensions", 1),
    "msix": ("dmap.supportsindex", 1),
    "mslr": ("dmap.loginrequired", 1),
    "mspi": ("dmap.supportspersistentids", 1),
    "msqy": ("dmap.supportsquery", 1),
    "msrs": ("dmap.supportsresolve", 1),
    "msrv": ("dmap.serverinforesponse", 12),
    "mstc": ("dmap.utctime", 10),
    "mstm": ("dmap.timeoutinterval", 5),
    "msto": ("dmap.utcoffset", 6),
    "msts": ("dmap.statusstring", 9),
    "mstt": ("dmap.status", 5),
    "msup": ("dmap.supportsupdate", 1),
    "mtco": ("dmap.specifiedtotalcount", 5),
    "mudl": ("dmap.deletedidlisting", 12),
    "mupd": ("dmap.updateresponse", 12),
    "musr": ("dmap.serverrevision", 5),
    "muty": ("dmap.updatetype", 1),
    "ppro": ("dpap.protocolversion", 5),
    "pret": ("dpap.unknown", 12),
}

dmap_data_types = {
    1: "b",   # byte
    2: "ub",  # unsigned byte
    3: "h",   # short
    4: "uh",  # unsigned short
    5: "i",   # integer
    6: "ui",  # unsigned integer
    7: "l",   # long
    8: "ul",  # unsigned long
    9: "s",   # string
    10: "t",  # timestamp
    11: "v",  # version
    12: "c",  # container
}

dmap_names = {
    dmap_code_types[k][0]: k for k in dmap_code_types
}

dmap_reverse_data_types = {
    dmap_data_types[k]: k for k in dmap_data_types
}
